
Ruby - Bug #3320

Feature # 5142 (Rejected): Remove ruby-mode.el from ruby's repo

emacs ruby-mode.el font-lock fails on symboled string ending with ?

05/20/2010 12:08 AM - zev (Zev Blut)

Status: Third Party's Issue   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 1.9.4   

ruby -v: 1.9.2 (trunk and 1.8.7)+ Backport:  

Description

=begin

Fontification breaks when emacs sees a symbol like

:'this is a symbol?'

example code:

class EmacsExample

:symbol

'this is a test'

'is this a test?'

"Can this be a test"

:'this is an error?'

def bar

@help

end

end

I have a very hacked fix in ruby-font-lock-syntactic-keywords

for

;; the last $', $", $ in the respective string is not variable ;; the last ?', ?", ? in the respective string is not ascii code

("\(^\|[[ \t\n<+(,=:]\)\(['"]\\)\\(\\\\.\\|\\2\\|[^'\"\n\\]\)*?\\?[?$]\(\2\)"

(2 (7 . nil))

(4 (7 . nil)))

by adding : in the above matches with space tabs L etc...

See the attached patch

I am not sure this is the proper fix, but it fixes the above example.

Thanks,

Zev

=end

Related issues:

Related to Ruby - Feature #6823:  Where/how should ruby-mode issues be reported? Closed

Has duplicate Ruby - Bug #4398: Highlighting of "'?" in Emacs Third Party's Issue02/15/2011

History

#1 - 05/20/2010 12:21 AM - zev (Zev Blut)

- File ruby-mode.el.patch added

=begin

=end
#2 - 05/20/2010 10:18 PM - zev (Zev Blut)

=begin

I found another related parse error.  Unfortunately, I am not sure how to fix this one.

This is a multi line string that starts on one line and ends on a different line with a ?

Such as:

x = 'What do you think about this long

text today ?'

def foo

end

=end

#3 - 05/21/2010 06:28 PM - zenspider (Ryan Davis)

=begin

On May 20, 2010, at 06:18 , Zev Blut wrote:

Issue #3320 has been updated by Zev Blut.

I found another related parse error.  Unfortunately, I am not sure how to fix this one.

This is a multi line string that starts on one line and ends on a different line with a ?

Such as:

x = 'What do you think about this long

text today ?'

def foo

end

 In this case it is because it sees ?' or ?" and interprets that as the character notation (I have no idea what this is called). Putting a backslash in front of

the ? fixes the problem locally.

There are a lot of different things that can trip up ruby-mode when inside a string. I tripped on one today with a multiline string with "def" in it:

eval "

def xxx

yyy

end

"

Notice that tab will indent up to the yyy as if it is actual code, not string content.

BTW, I'm using version 1.0 of ruby-mode.el as supplied in emacs 24.0.50. It may be more up to date in the ruby distro, but afaik, it should be shifting

to emacs for distribution.

=end

#4 - 06/26/2011 01:46 PM - akr (Akira Tanaka)

- Project changed from 8 to Ruby

- Category deleted (misc)

- Assignee set to nobu (Nobuyoshi Nakada)

#5 - 06/26/2011 04:49 PM - nahi (Hiroshi Nakamura)

- Target version set to 1.9.3

#6 - 07/11/2011 03:09 PM - kosaki (Motohiro KOSAKI)

- Status changed from Open to Assigned

#7 - 07/21/2011 02:55 PM - kosaki (Motohiro KOSAKI)

- Target version changed from 1.9.3 to 1.9.4
ETIMEOUT. ruby-mode.el never be release stopper.

#8 - 08/02/2011 10:48 AM - naruse (Yui NARUSE)

- Parent task set to #5142

#9 - 12/04/2012 05:45 AM - dgutov (Dmitry Gutov)

All examples in this bug work fine for me with ruby-mode from the Emacs tree.

Not sure when they were fixed.

#10 - 12/06/2012 05:48 PM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Third Party's Issue

Files

ruby-mode.el.patch 1.63 KB 05/20/2010 zev (Zev Blut)
